package de.unibi.airobots.btl.data.navigation;

/*
 * #LICENSE%
 * BielefeldTypeLibrary
 * ---
 * Copyright (C) 2009 - 2013 Frederic Siepmann
 * ---
 * This file is part of Bielefeld Type Library (BTL).
 * 
 * http://opensource.cit-ec.de/projects/btl
 * 
 * This file may be licensed under the terms of of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 * 
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 * 
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * The development of this software was supported by the
 * Excellence Cluster EXC 277 Cognitive Interaction Technology.
 * The Excellence Cluster EXC 277 is a grant of the Deutsche
 * Forschungsgemeinschaft (DFG) in the context of the German
 * Excellence Initiative.
 * 
 * Contributors: Florian Lier, Frederic Siepmann, Leon Ziegler, Matthias 
 * Schoepfer, Adriana-Victoria Dreyer, Agnes Swadzba, Andreas Kipp, Birte 
 * Carlmeyer, Christian Ascheberg, Daniel Nacke, Dennis Wigand, Günes Minareci, 
 * Hendrik ter Horst, Ingo Killmann, Jan Pöppel, Lukas Kettenbach, Michael 
 * Zeunert, Patrick Renner, Philipp Dresselhaus, Sebastian Meyer zu Borgsen, 
 * Soufian Jebbara, Tobias Röhlig, Torben Toeniges, Viktor Losing, Viktor Richter
 * %LICENSE#
 */

import de.unibi.airobots.btl.Type;
import nu.xom.Element;
import nu.xom.Nodes;

/**
 *
 * @author pdressel
 */
public abstract class ROSDynamicConfiguration extends Type {
    
    public static final String BASETAG = "DYNAMICCONFIGURATIONBASE";
    
    /**
     *
     * Hide the supertypes implementation. Returns the tag name of the the root
     * tag this type is usually used with in xml.
     *
     * @return tag name
     */
    public static String getBaseTag() {
        return ROSDynamicConfiguration.BASETAG;
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
    public void sanitizeElement(Element parent) {

        super.sanitizeElement(parent);

        Nodes nodes = parent.query(ROSDynamicConfiguration.BASETAG);
        for (int i = 0; i < nodes.size(); i++) {
            parent.removeChild(nodes.get(i));
        }
    }
    
    @Override
    public void fillInto(Element parent) {
        
        super.fillInto(parent);
    }
    
    public abstract void setRestoreDefaults(boolean restore_defaults);
}
