package de.unibi.airobots.btl.data.person;

/*
 * #LICENSE%
 * BielefeldTypeLibrary
 * ---
 * Copyright (C) 2009 - 2013 Frederic Siepmann
 * ---
 * This file is part of Bielefeld Type Library (BTL).
 * 
 * http://opensource.cit-ec.de/projects/btl
 * 
 * This file may be licensed under the terms of of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 * 
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 * 
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 * 
 * The development of this software was supported by the
 * Excellence Cluster EXC 277 Cognitive Interaction Technology.
 * The Excellence Cluster EXC 277 is a grant of the Deutsche
 * Forschungsgemeinschaft (DFG) in the context of the German
 * Excellence Initiative.
 * 
 * Contributors: Florian Lier, Frederic Siepmann, Leon Ziegler, Matthias 
 * Schoepfer, Adriana-Victoria Dreyer, Agnes Swadzba, Andreas Kipp, Birte 
 * Carlmeyer, Christian Ascheberg, Daniel Nacke, Dennis Wigand, Günes Minareci, 
 * Hendrik ter Horst, Ingo Killmann, Jan Pöppel, Lukas Kettenbach, Michael 
 * Zeunert, Patrick Renner, Philipp Dresselhaus, Sebastian Meyer zu Borgsen, 
 * Soufian Jebbara, Tobias Röhlig, Torben Toeniges, Viktor Losing, Viktor Richter
 * %LICENSE#
 */

import de.unibi.airobots.btl.data.geometry.Point3D;
import nu.xom.Element;
import nu.xom.ParsingException;

/**
 * A simple type that represents the position of a hand.
 *
 * @author lkettenb
 */
public class HandPos extends Point3D {

    public static String getBaseTag() {
        return "HANDPOS";
    }

    /**
     * Constructs a {@link Point3D} object from a given XOM {@link Element}.
     *
     * @param objectElement The XOM {@link Element} to construct an object from.
     * @return The {@link Point3D} object containing all the information given
     * by the {@link Element} object.
     */
    public static void fromElement(Element objectElement, HandPos object) 
            throws ParsingException {
        Point3D.fromElement(objectElement, object);
    }

    /**
     * Constructs a {@link Point3D} object from a given XOM {@link Element}.
     *
     * @param objectElement The XOM {@link Element} to construct an object from.
     * @return The {@link Point3D} object containing all the information given
     * by the {@link Element} object.
     */
    public static Point3D fromElement(Element objectElement)
            throws ParsingException {
        return Point3D.fromElement(objectElement);
    }
}
